﻿@{
    ViewBag.Title = "IssuesList";
    //Layout = null;
}

<h2>IssuesList</h2>

<link rel="stylesheet" type="text/css" href="~/Content/demos.css" />
<link href='http://fonts.googleapis.com/css?family=Open+Sans:300,600,400' rel='stylesheet' type='text/css'>
<link rel="stylesheet" type="text/css" href="~/Content/css/jsgrid.css" />
<link rel="stylesheet" type="text/css" href="~/Content/css/theme.css" />
<script src="~/Content/db.js"></script>
<script src="~/Content/src/jsgrid.core.js"></script>
<script src="~/Content/src/jsgrid.load-indicator.js"></script>
<script src="~/Content/src/jsgrid.load-strategies.js"></script>
<script src="~/Content/src/jsgrid.sort-strategies.js"></script>
<script src="~/Content/src/jsgrid.field.js"></script>
<script src="~/Content/src/fields/jsgrid.field.text.js"></script>
<script src="~/Content/src/fields/jsgrid.field.number.js"></script>
<script src="~/Content/src/fields/jsgrid.field.select.js"></script>
<script src="~/Content/src/fields/jsgrid.field.checkbox.js"></script>
<script src="~/Content/src/fields/jsgrid.field.control.js"></script>
<script src="https://code.jquery.com/ui/1.12.0/jquery-ui.min.js"></script>

<style>
    .modal {
        text-align: center;
        padding: 0 !important;
    }

        .modal:before {
            content: '';
            display: inline-block;
            height: 100%;
            vertical-align: middle;
            margin-right: -4px;
        }

    .modal-dialog {
        display: inline-block;
        text-align: left;
        vertical-align: middle;
    }

    .center {
        text-align: center !important;
    }

    .trSelected {
        border-color: GreenYellow !important;
        background-color: GreenYellow !important;
    }
</style>
<div class="container">
    @using (Html.BeginForm())
    {
        <div class="row">
            <div class="col-sm-3">
                @Html.Label("ProjectList", "Select Project")
                @Html.DropDownList("ProjectList", new SelectList(ViewBag.ProjectList, "Value", "Text"), "select Project", new { @class = "form-control" })
            </div>
            <div class="col-sm-3">
                @Html.Label("UserList", "Select User")
                @Html.DropDownList("UserList", new SelectList(new List<SelectListItem>()), "select User", new { @class = "form-control" })
            </div>
        </div>
    }
    <br />

    <div class="row">
        <div class="col-sm-12" id="Issues">
        </div>
    </div>
</div>
<div id="Loader" style="width: 100%; height: 100%; background-color: gray; opacity: 0.5; position: fixed;top:0px;left:0px; z-index: 10000;display:none">
    <div style=" margin: auto; color: red; position: fixed; top: 20%; left: 40%; background-color: white; width: 20%; opacity: 1!important;">
        <img width="100%" src="~/Content/gears.gif" />
    </div>
</div>
<br />
<!-- Model Popup-->
<div class="modal fade" id="ModalTimeSpent" role="dialog">
    <div class="modal-dialog">
        <!-- Modal content-->
        <div class="modal-content" style="border-radius:0">
            <div class="modal-header trSelected" style="height:35px;padding-top:5px;">
                <button type="button" class="close" data-dismiss="modal" style="font-size:xx-large">&times;</button>
                <h4 class="modal-title">Time Spents</h4>
            </div>
            <div class="modal-body">
                <p>All the time spents mentioned by the developer for the particular task\issue- <span id="id"></span></p>
            </div>
            <div class="modal-footer trSelected" style="padding:5px;">
                <button type="button" class="btn btn-default fc" data-dismiss="modal">Close</button>
            </div>
        </div>

    </div>
</div>
<script>
    $(document).ready(function () {
        $('#ProjectList').change(function () {
            $('#Loader').show();
            $("#jsGrid").jsGrid({ controller: { loadData: function (filter) { return [] } } });
            GetUsers($('#ProjectList option:selected').val());
        });
        $('#UserList').change(function () {
            $('#Loader').show();
            var Issue = $.post("/AssignedIssue/GetIssues", { ProjectId: $('#ProjectList option:selected').val(), UserId: $('#UserList option:selected').val() });
            Issue.done(function (Result) {
                $('#Issues').empty();
                //$.each(Result, function () {
                //    $('#Issues').append('<h3 style="color:blue;border:1px solid red;">' + this['title'] + '</h3>')
                //});
                grd(Result);
                $('#Loader').hide();
            }).fail(function (Result) {
                alert(Result);
                $('#Loader').hide();
            });
        });
        $('#btn').click(function (e) {
            var a = $("#jsGrid").jsGrid("option", "data");
            e.preventDefault();
        });
    });
    function GetUsers(ProjectId) {
        var Users = $.post("/AssignedIssue/GetUsers", { ProjectId: ProjectId });
        Users.done(function (Result) {
            ddlPopulate("UserList", Result);
            $('#Loader').hide();
        }).fail(function (Result) {
            alert(Result);
            $('#Loader').hide();
        });
    }
    function ddlPopulate(id, list) {
        $('#' + id).empty();
        $('#' + id).append('<option value>select User</option>');
        $.each(list, function () {
            $('#' + id).append('<option value="' + this['Value'] + '">' + this['Text'] + '</option>');
        });
    }
</script>
<div id="jsGrid"></div>
<script>
    countries = [
            { Name: "", Id: "" },
            { Name: "Opened", Id: "opened" },
            { Name: "Closed", Id: "closed" }
    ];
    function grd(d) {

        $("#jsGrid").jsGrid({
            height: "70%",
            width: "100%",
            sorting: true,
            paging: true,
            filtering: true,
            autoload: true,
            pageSize: 25,
            //headerRowRenderer: function () {
            //    return '<tr><td colspan="5">vikas</td></tr>';
            //},
            rowClick: function (args) {
                $("#ModalTimeSpent #id").html("<br><br>Issue Id:- " + args.item.id + "<br>Total Time Spents:- " + args.item.human_total_time_spent + "<br>Time_estimate:- " + args.item.human_time_estimate);

                $("td").removeClass("trSelected");
                $(args.event.target).parent().children("td").addClass("trSelected");
                $("#ModalTimeSpent").modal();
                $("#ModalTimeSpent").draggable({
                    handle: ".modal-header"
                });
                $(".fc").focus();
            },
            rowDoubleClick: function (args) {
                //$("#ModalTimeSpent #id").html("<br>Issue Id:- " + args.item.id + "   Time Spents:- " + args.item.timeSpent + "<br>Issue Id:- " + args.item.id + "   Time Spents:- " + args.item.timeSpent);
                //$("#ModalTimeSpent").modal();
            },
            pageButtonCount: 5,
            controller: {
                loadData: function (filter) {
                    return $.grep(d, function (item) {
                        return (!filter.title || item.title.indexOf(filter.title) > -1)
                            && (!filter.assignee || item.assignee.indexOf(filter.assignee) > -1)
                            && (!filter.timeSpent || item.timeSpent == filter.timeSpent)
                            && (!filter.timeEst || item.timeEst == filter.timeEst)
                            && (!filter.due_date || item.due_date.indexOf(filter.due_date) > -1)
                            && (!filter.created_at || item.created_at.indexOf(filter.created_at) > -1)
                            && (!filter.Status || item.Status === filter.Status);
                    });
                    //return d;
                },
                updateItem: function (item) {
                    var a = item;
                },
                deleteItem: function (item) {
                    var a = item;
                }
            },
            fields: [
                { name: "SrNo", type: "number", width: 30, filtering: false, css: "center" },
                { name: "title", type: "text", width: 250 },
                { name: "assignee", type: "text", width: 100 },
                { name: "timeSpent", type: "number", width: 50 },
                { name: "timeEst", type: "number", width: 50 },
                { name: "due_date", type: "text", width: 50 },
                { name: "created_at", type: "text", width: 50 },
                { name: "Status", type: "select", items: countries, valueField: "Id", textField: "Name" },
            ]
        });

    }
</script>
<script src="//cdn.rawgit.com/rainabba/jquery-table2excel/1.1.0/dist/jquery.table2excel.min.js"></script>
<button class="aa">click</button>
<script>
    $('.aa').click(function () {
        $("#jsGrid").table2excel({
            exclude: ".excludeThisClass",
            name: "Worksheet Name",
            filename: "SomeFile" //do not include extension
        });
    });
</script>
